class B implements Cloneable {
	
	private int top;
	private int[] buffer;
	
	public B(int maxContents) {
		buffer = new int[maxContents];
		top = -1;
	}
	
	public void push(int val) {
		buffer[++top] = val;
	}
	
	public int pop() {
		return buffer[top--];
	}
	
	public int getTop() {
		return buffer[top];
	}
	
	// bad clone overriding

	// @Override
	// public B clone() {
	// 	try {
	// 		return (B) super.clone(); // call for Object.clone()
	// 	} catch (CloneNotSupportedException e) {
	// 		// Cannot happen -- 'cause we supported the clone
	// 		throw new InternalError(e.toString());
	// 	}
	// }

	
	// proper clone overriding

	// @Override
	public B clone() {
		try {
			B tmp = (B) super.clone(); // recreating the old object with shared
									   // reference fields
			tmp.buffer = buffer.clone(); // calling the corresponding field's clone
			return tmp; // provided buffer.clone() is already correct
		} catch (CloneNotSupportedException e) {
			// Cannot happen -- 'cause we supported the clone
			throw new InternalError(e.toString());
		}
	}
	
	public static void main(String[] args) {
		B first = new B(2);
		first.push(3);
		first.push(7);
		B second = first.clone();

		System.out.println(second.getTop());
		System.out.println(first.pop());
		first.push(11);
		System.out.println(first.getTop());
		System.out.println(second.getTop());
	}
}